micro_utils.dokka
0.15.1

# ReadKeyValueRepo

interface ReadKeyValueRepo<Key, Value> : Repo

Read part of KeyValueRepo

#### Parameters

Key

This type will be used as key in all operations related to searches of data

Value

This type will be used as returning data in most "get" operations

## Functions

contains
Link copied to clipboard
abstract suspend fun contains(key: Key): Boolean
count
Link copied to clipboard
abstract suspend fun count(): Long
get
Link copied to clipboard
abstract suspend fun get(k: Key): Value?
keys
Link copied to clipboard
abstract suspend fun keys(pagination: Pagination, reversed: Boolean = false): PaginationResult<Key>
abstract suspend fun keys(v: Value, pagination: Pagination, reversed: Boolean = false): PaginationResult<Key>

This method should use sorted by Keys search and take the PaginationResult. By default, it should use ascending sort for Keys

values
Link copied to clipboard
abstract suspend fun values(pagination: Pagination, reversed: Boolean = false): PaginationResult<Value>

This method should use sorted by Keys search and take the PaginationResult. By default, it should use ascending sort for Keys

## Inheritors

KeyValueRepo
Link copied to clipboard
DelegateBasedKeyValueRepo
Link copied to clipboard
ReadMapKeyValueRepo
Link copied to clipboard
MapKeyValueRepo
Link copied to clipboard
ReadKeyValueCacheRepo
Link copied to clipboard
FullReadKeyValueCacheRepo
Link copied to clipboard
FullKeyValueCacheRepo
Link copied to clipboard
MapperReadKeyValueRepo
Link copied to clipboard
MapperKeyValueRepo
Link copied to clipboard
KtorReadKeyValueRepoClient
Link copied to clipboard
FileReadKeyValueRepo
Link copied to clipboard
FileKeyValueRepo
Link copied to clipboard
AbstractExposedReadKeyValueRepo
Link copied to clipboard
ExposedReadKeyValueRepo
Link copied to clipboard

## Extensions

cached
Link copied to clipboard
fun <Key, Value> ReadKeyValueRepo<Key, Value>.cached(kvCache: KVCache<Key, Value>): ReadKeyValueCacheRepo<Key, Value>
fun <Key, Value> ReadKeyValueRepo<Key, Value>.cached(kvCache: FullKVCache<Key, Value>): FullReadKeyValueCacheRepo<Key, Value>
withMapper
Link copied to clipboard
inline fun <FromKey, FromValue, ToKey, ToValue> ReadKeyValueRepo<ToKey, ToValue>.withMapper(mapper: MapperRepo<FromKey, FromValue, ToKey, ToValue>): ReadKeyValueRepo<FromKey, FromValue>
inline fun <FromKey, FromValue, ToKey, ToValue> ReadKeyValueRepo<ToKey, ToValue>.withMapper(noinline keyFromToTo: suspend FromKey.() -> ToKey = { this as ToKey }, noinline valueFromToTo: suspend FromValue.() -> ToValue = { this as ToValue }, noinline keyToToFrom: suspend ToKey.() -> FromKey = { this as FromKey }, noinline valueToToFrom: suspend ToValue.() -> FromValue = { this as FromValue }): ReadKeyValueRepo<FromKey, FromValue>